/* cgmanager
 *
 * Copyright (C) 2010 Scott James Remnant <scott@netsplit.com>.
 *
 * This file was automatically generated; see the source for copying
 * conditions.
 */

#ifndef CGMANAGER_CGMANAGER_CLIENT_H
#define CGMANAGER_CGMANAGER_CLIENT_H

#include <dbus/dbus.h>

#include <stdint.h>

#include <nih/macros.h>

#include <nih-dbus/dbus_interface.h>
#include <nih-dbus/dbus_message.h>
#include <nih-dbus/dbus_pending_data.h>
#include <nih-dbus/dbus_proxy.h>


typedef void (*CgmanagerPingReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerGetPidCgroupScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerGetPidCgroupReply) (void *data, NihDBusMessage *message, const char *output);

typedef void (*CgmanagerCreateScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerCreateReply) (void *data, NihDBusMessage *message, int32_t existed);

typedef void (*CgmanagerChownCgroupScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerChownCgroupReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerMovePidScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerMovePidReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerGetValueScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerGetValueReply) (void *data, NihDBusMessage *message, const char *value);

typedef void (*CgmanagerSetValueScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerSetValueReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerRemoveScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerRemoveReply) (void *data, NihDBusMessage *message, int32_t existed);

typedef void (*CgmanagerGetTasksScmReply) (void *data, NihDBusMessage *message);

typedef void (*CgmanagerGetTasksReply) (void *data, NihDBusMessage *message, const int32_t *output, size_t output_len);


NIH_BEGIN_EXTERN

extern const NihDBusInterface  cgmanager_org_linuxcontainers_cgmanager0_0;
extern const NihDBusInterface *cgmanager_interfaces[];


DBusPendingCall *cgmanager_ping                    (NihDBusProxy *proxy, int32_t junk, CgmanagerPingReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_ping_sync               (const void *parent, NihDBusProxy *proxy, int32_t junk)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_get_pid_cgroup_scm      (NihDBusProxy *proxy, const char *controller, int sockfd, CgmanagerGetPidCgroupScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_get_pid_cgroup_scm_sync (const void *parent, NihDBusProxy *proxy, const char *controller, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_get_pid_cgroup          (NihDBusProxy *proxy, const char *controller, int32_t pid, CgmanagerGetPidCgroupReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_get_pid_cgroup_sync     (const void *parent, NihDBusProxy *proxy, const char *controller, int32_t pid, char **output)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_create_scm              (NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd, CgmanagerCreateScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_create_scm_sync         (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_create                  (NihDBusProxy *proxy, const char *controller, const char *cgroup, CgmanagerCreateReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_create_sync             (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t *existed)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_chown_cgroup_scm        (NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd, CgmanagerChownCgroupScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_chown_cgroup_scm_sync   (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_chown_cgroup            (NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t uid, int32_t gid, CgmanagerChownCgroupReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_chown_cgroup_sync       (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t uid, int32_t gid)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_move_pid_scm            (NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd, CgmanagerMovePidScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_move_pid_scm_sync       (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_move_pid                (NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t pid, CgmanagerMovePidReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_move_pid_sync           (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t pid)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_get_value_scm           (NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, int sockfd, CgmanagerGetValueScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_get_value_scm_sync      (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_get_value               (NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, CgmanagerGetValueReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_get_value_sync          (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, char **value)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_set_value_scm           (NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, const char *value, int sockfd, CgmanagerSetValueScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_set_value_scm_sync      (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, const char *value, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_set_value               (NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, const char *value, CgmanagerSetValueReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_set_value_sync          (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, const char *key, const char *value)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_remove_scm              (NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t recursive, int sockfd, CgmanagerRemoveScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_remove_scm_sync         (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t recursive, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_remove                  (NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t recursive, CgmanagerRemoveReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_remove_sync             (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t recursive, int32_t *existed)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_get_tasks_scm           (NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd, CgmanagerGetTasksScmReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_get_tasks_scm_sync      (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int sockfd)
	__attribute__ ((warn_unused_result));
DBusPendingCall *cgmanager_get_tasks               (NihDBusProxy *proxy, const char *controller, const char *cgroup, CgmanagerGetTasksReply handler, NihDBusErrorHandler error_handler, void *data, int timeout)
	__attribute__ ((warn_unused_result));
int              cgmanager_get_tasks_sync          (const void *parent, NihDBusProxy *proxy, const char *controller, const char *cgroup, int32_t **output, size_t *output_len)
	__attribute__ ((warn_unused_result));

NIH_END_EXTERN

#endif /* CGMANAGER_CGMANAGER_CLIENT_H */
